import 'dart:async';
import 'dart:core';
import 'package:flutter_firebase_basic_tools/logic/google_translation_api.dart';

class TranslationStream {
  List<StreamController<String>> controllers = List<StreamController<String>>();
  List<Stream> streams = List<Stream>();
  List<String> originalTexts = List<String>();

  init(List<String> textList, Function parentFunction) {
    for (int i = 0; i < textList.length; i++) {
      controllers.add(StreamController<String>());
      streams.add(controllers[i].stream);
      originalTexts.add("");
    }

    for (int i = 0; i < textList.length; i++) {
      originalTexts[i] = textList[i];

      streams[i].listen((newText) {
        parentFunction(i, newText);
      });

      controllers[i].add(originalTexts[i]);
    }
  }

  translate() async {
    for (int i = 0; i < originalTexts.length; i++) {
      addNewTranslatedText(i);
    }
  }

  addNewTranslatedText(int i) async {
    controllers[i]
        .add(await GoogleTranslationApi().translate(originalTexts[i]));
  }
}
